.486p
.387
.Model Flat
DATA SEGMENT PARA PUBLIC 'DATA'
       EXTRN _Pal_Neu: BYTE 768 dup (0)                 ;paleta: crna, les 255
       EXTRN _VGA: BYTE 312002 dup (0)
                   ; Old         dw      0
                   ; Virtual     db      307200 dup (0)         +2
                   ; Pre         db      60*80 dup (0)          +307202
       EXTRN _Command: BYTE       8 dup (0)
                   ; Ext         db      0                      +0
                   ; KeyNo       db      0                      +1
                   ; Keys        db      3 dup (0)              +2
                   ; Release     db      3 dup (0)              +5
        EXTRN _Tree: BYTE         10242 dup (0)
                   ; Years       dw      0                      +0
                   ; dR          float   128 dup (0)            +2
                   ; R           float   128 dup (0)            +514
                   ; H           float   128 dup (0)            +1026
                   ; Veje        db      128 dup (0)            +1538
                   ; Phi         float   128*8 dup (0)          +2050
                   ; HPhi        float   128*8 dup (0)          +6146
        EXTRN _View: BYTE         24 dup (0)
                   ; X           float       dup (0)            +0
                   ; Y           float       dup (0)            +4
                   ; Z           float       dup (0)            +8
                   ; Theta       float       dup (0)            +12
                   ; Phi         float       dup (0)            +16
                   ; Zoom        float       dup (0)            +20
DATA ENDS

_TEXT SEGMENT PARA 'CODE'

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

PUBLIC VESA_Init_VGA_
VESA_Init_VGA_ PROC                                     ; << OK >>
                pushad
                mov     eax, 00004F03H          
                int     10H                     
                mov     WORD PTR [_VGA], bx                     ; .Old
                xor     ebx, ebx                
                mov     bx, 101H                                ; bx, dx
                mov     eax, 00004F02H          
                int     10H                     
                mov     eax, 00001013H          
                mov     ebx, 00000000H          
                int   10H                     
                popad
                ret
VESA_Init_VGA_ ENDP

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

PUBLIC VESA_Exit_VGA_
VESA_Exit_VGA_ PROC                                     ; << OK >>
                pushad                        
                xor   ebx, ebx                
                mov   bx, WORD PTR [_VGA]                       ; .Old
                mov   eax, 00004F02H          
                int   10H                     
                popad                         
                ret
VESA_Exit_VGA_ ENDP

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

PUBLIC Check_Key_                                               ; OK
Check_Key_ PROC
                                        ; Main Char       ... [ebx] = 0
                                        ; Ext Char        ... [ebx] = 1
                                        ; Prihaja (42)Ext ... [ebx] = 2 
                                        ; Prihaja (Ext)?? ... [ebx] = 1
                                        ; 2Ext Chars      ... [ebx] = 4 Pause
                                        ; 2Ext Chars 2nd  ... [ebx] = 5 Pause
                                        ; 2Ext Chars Rel  ... [ebx] = 6 Pause
                                        ; 2Ext Chars 1st R... [ebx] = 7 Pause
                                        ; 2Ext Chars 2nd R... [ebx] = 8 Pause
                cli
                pushad
                xor     ecx, ecx

                lea     ebx, _Command
                mov     dl, [ebx]
                cmp     dl, 1
                je      @KeyH_Ext
                cmp     dl, 2
                je      @KeyH_42Ext0
                cmp     dl, 4
                je      @KeyH_Pause_P
                cmp     dl, 5
                je      @KeyH_Pause_P2
                cmp     dl, 6
                je      @KeyH_Pause_R
                cmp     dl, 7
                je      @KeyH_Pause_R1
                cmp     dl, 8
                je      @KeyH_Pause_R2
                                        ; Normal Char v tem INT 9
                in      al, 60h
                cmp     al, 0E1h
                je      @KeyH_Pause
                cmp     al, 0E0h
                jne     @KeyH_Ch
                                        ; Ext Char v naslednjem INT 9
                mov     [ebx], BYTE PTR 1
                jmp     @KeyH_End
@KeyH_Pause:    in      al, 60h
                mov     [ebx], BYTE PTR 4     ; 2Ext Chars v naslednjem INT 9
                jmp     @KeyH_End
@KeyH_42Ext0:   in      al, 60h
                mov     [ebx], BYTE PTR 1
                jmp     @KeyH_End
@KeyH_Ch:
                bt      eax, 7
                jc      @KeyH_Ch_Rel
                                        ; Normal Char Pressed
                cmp     al, 29          ; Set bits 012 v .Release[2], ce 
                sete    cl              
                or      [ebx+7], cl
                cmp     al, 56
                sete    cl
                shl     cl, 1
                or      [ebx+7], cl
                cmp     al, 83
                sete    cl
                shl     cl, 2
                or      [ebx+7], cl     ; stisnjeni Ctrl-Alt-Del
                inc     ebx
                mov     ah, [ebx]
                cmp     ah, 3
                jge     @KeyH_End
                bt      eax, 8
                jnc     @KCh1
                cmp     al, [ebx+1]
                je      @KeyH_End
                or      ah, 2
                mov     [ebx], ah
                add     ebx, 2
                jmp     @KCh2
        @KCh1:  cmp     al, [ebx+2]
                je      @KeyH_End
                or      ah, 1
                mov     [ebx], ah
                inc     ebx
        @KCh2:  mov     [ebx], al
                mov     [ebx+3], BYTE PTR 1
                jmp     @KeyH_End
@KeyH_Pause_P:  in      al, 60h
                mov     [ebx], BYTE PTR 5
                inc     ebx
                mov     ah, [ebx]
                cmp     ah, 3
                jge     @KeyH_End
                bt      eax, 8
                jnc     @KPP1
                cmp     [ebx+1], BYTE PTR 198
                je      @KeyH_End
                or      ah, 2
                mov     [ebx], ah
                add     ebx, 2
                jmp     @KPP2
        @KPP1:  cmp     [ebx+2], BYTE PTR 198
                je      @KeyH_End
                or      ah, 1
                mov     [ebx], ah
                inc     ebx
        @KPP2:  mov     [ebx], BYTE PTR 198
                mov     [ebx+3], BYTE PTR 1
                jmp     @KeyH_End
@KeyH_Pause_P2: in      al, 60h
                mov     [ebx], BYTE PTR 6
                jmp     @KeyH_End
@KeyH_Pause_R:  in      al, 60h
                mov     [ebx], BYTE PTR 7
                jmp     @KeyH_End
@KeyH_Pause_R1: in      al, 60h
                mov     [ebx], BYTE PTR 8
                jmp     @KeyH_End
@KeyH_Pause_R2: in      al, 60h
                mov     [ebx], BYTE PTR 0
                jmp     @KeyH_End
                                        ; Normal Char Released
@KeyH_Ch_Rel:   and     al, 127
                cmp     al, 29          ; izbrise bite 012 v .Release[2] ce
                sete    cl
                xor     cl, 7
                and     [ebx+7], cl
                cmp     al, 56
                sete    cl
                shl     cl, 1
                xor     cl, 7
                and     [ebx+7], cl
                cmp     al, 83
                sete    cl
                shl     cl, 2
                xor     cl, 7
                and     [ebx+7], cl     ; stisnjeni Ctrl-Alt-Del
                add     ebx, 2
                cmp     al, [ebx]
                je      @KCR1
                inc     ebx
                cmp     al, [ebx]
                jne     @KeyH_End
                and     [ebx-2], BYTE PTR 00000001b
                jmp     @KCR2
        @KCR1:  and     [ebx-1], BYTE PTR 00000010b
        @KCR2:  mov     [ebx], BYTE PTR 0
                mov     [ebx+3], BYTE PTR 0
                jmp     @KeyH_End
@KeyH_Ext:                              ; Ext Char v tem INT 9
                in      al, 60h
                bt      eax, 7
                jc      @KeyH_Ex_Rel
                cmp     al, 42
                jne     @KeyH_Ext_1
                mov     [ebx], BYTE PTR 2
                jmp     @KeyH_End
  @KeyH_Ext_1:                          ; Ext Ch Pressed
                mov     [ebx], BYTE PTR 0
                inc     ebx
                or      al, 128
                cmp     al, 157         ; postavi bite 012 v .Release[2] ce
                sete    cl
                or      [ebx+6], cl
                cmp     al, 184
                sete    cl
                shl     cl, 1
                or      [ebx+6], cl
                cmp     al, 211
                sete    cl
                shl     cl, 2
                or      [ebx+6], cl     ; so stisnjeni Ctrl-Alt-Del
                mov     ah, [ebx]
                cmp     ah, 3
                jge     @KeyH_End
                bt      eax, 8
                jnc     @KEx1
                cmp     al, [ebx+1]
                je      @KeyH_End
                or      ah, 2
                mov     [ebx], ah
                add     ebx, 2
                jmp     @KEx2
        @KEx1:  cmp     al, [ebx+2]
                je      @KeyH_End
                or      ah, 1
                mov     [ebx], ah
                inc     ebx
        @KEx2:  mov     [ebx], al
                mov     [ebx+3], BYTE PTR 1
                jmp     @KeyH_End
                                        ; Ext Ch Released
@KeyH_Ex_Rel:   mov     [ebx], BYTE PTR 0
                cmp     al, 170
                je      @KeyH_End
                cmp     al, 198
                je      @KeyH_End
                cmp     al, 157         ; stisne bite 012 v .Release[2] ce
                sete    cl
                xor     cl, 7
                and     [ebx+7], cl
                cmp     al, 184
                sete    cl
                shl     cl, 1
                xor     cl, 7
                and     [ebx+7], cl
                cmp     al, 211
                sete    cl
                shl     cl, 2
                xor     cl, 7
                and     [ebx+7], cl     ; so stisnjeni Ctrl-Alt-Del
                add     ebx, 2
                cmp     al, [ebx]
                je      @KExR1
                inc     ebx
                cmp     al, [ebx]
                jne     @KeyH_End
                and     [ebx-2], BYTE PTR 00000001b
                jmp     @KExR2
        @KExR1: and     [ebx-1], BYTE PTR 00000010b
        @KExR2: mov     [ebx], BYTE PTR 0
                mov     [ebx+3], BYTE PTR 0
@KeyH_End:      mov     al, 20h
                out     20h, al
                ;cmp     BYTE PTR [_Command + 7], 7
                ;jne     @KeyH_NoReboot
                ;int    ??                               ; Reboot
@KeyH_NoReboot: popad
                sti
                ret
Check_Key_ ENDP

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

PUBLIC Pal_Norm_Init_
Pal_Norm_Init_ PROC
              pushad
              lea       esi, _Pal_Neu
              mov       bx, 256
   @Pn01:     mov       ax, 256
              sub       ax, bx
              mov       dx, 3C8h
              out       dx, al
              inc       dx
              lodsb
              out       dx, al
              lodsb
              out       dx, al
              lodsb
              out       dx, al
              dec       bx
              jnz       @Pn01
              popad
              ret
Pal_Norm_Init_ ENDP

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

PUBLIC Paste_
Paste_ PROC
                pushad
                lea     esi, _VGA + 2                           ;.Virtual
                mov     edi, 000A0000h
                xor     ebx, ebx
                xor     ecx, ecx
                xor     edx, edx
                mov     eax, 4F05h
                int     10h

                mov     ecx, 16384
                rep     movsd
                mov     edi, 000A0000h
                xor     ebx, ebx
                xor     ecx, ecx
                mov     edx, 1
                mov     eax, 4F05h
                int     10h

                mov     ecx, 16384
                rep     movsd
                mov     edi, 000A0000h
                xor     ebx, ebx
                xor     ecx, ecx
                mov     edx, 2
                mov     eax, 4F05h
                int     10h

                mov     ecx, 16384
                rep     movsd
                mov     edi, 000A0000h
                xor     ebx, ebx
                xor     ecx, ecx
                mov     edx, 3
                mov     eax, 4F05h
                int     10h

                mov     ecx, 16384
                rep     movsd
                mov     edi, 000A0000h
                xor     ebx, ebx
                xor     ecx, ecx
                mov     edx, 4
                mov     eax, 4F05h
                int     10h
                mov     ecx, 11264
                rep     movsd

                popad
                ret
Paste_ ENDP
    
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

_TEXT ENDS
END
