#include "TREEFILE.H"
#include "TREESTRC.H"
#include <stdio.h>
#include <string.h>

void 
Read_Pal (void)
{
  FILE *aa;
  DW i;
  aa = fopen(Names.PalName,"rb");
  fread(&Pal_Neu,768,1,aa); fclose(aa);
  for(i=0;i<256;i++){
    Pal_BGR[i*3+0] = Pal_Neu[i*3+2] * 4;
    Pal_BGR[i*3+1] = Pal_Neu[i*3+1] * 4;
    Pal_BGR[i*3+2] = Pal_Neu[i*3+0] * 4; }
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

void 
Save_File (void)
{
  FILE *aa;
  aa = fopen(Names.Name,"wb");
  fwrite(&TGA,18,1,aa);
  fwrite(&Pal_BGR,768,1,aa);
  fwrite(&VGA.Virtual,307200,1,aa); fclose(aa);
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

void 
Set_Names (char *Ptr)
{
  DW i;

  memcpy(&Names.Name,Ptr,12);
  do{ i++;
  } while (Names.Name[i] != 0x2E);
  if (i < 2){
    memcpy(&Names.Name[2],(Ptr+i),12);
    Names.CharNo = 0; } else {
    Names.CharNo = (i-2); }

  Names.PicNo = 0;
  Update_Names ();
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
  
void
Update_Names (void)
{
  DW j;

  j = (Names.PicNo >> 4);
  if (j < 0x0A){ j = (0x30 + j); } else
               { j = (0x37 + j); }
  Names.Name[Names.CharNo]   = j;
  j = (Names.PicNo & 15);
  if (j < 0x0A){ j = (0x30 + j); } else
               { j = (0x37 + j); }
  Names.Name[Names.CharNo+1] = j;
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
