#include "STANDARD.H"

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//  S Y S T E M 
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

extern "C" {
typedef struct { DW Old;
                 DB Virtual[480][640]; 
                 DB Pre[60][80]; } TypeVGA;

typedef struct { DB Ext, KeyNo, Keys[3], Release[3];
               } TypeCMD;

typedef struct { DW Years;                      // Koliko let je stara
                 float Exc;                     // Ekscentricnost
                 float Roots[5];                // Koti korenin
                 float dR[128], R[128], H[128]; // Radiji letnic in letni prirasti
                 DB Veje[128];                  // Koliko vej je na letnem prirastu, max 8
                 float Phi[128][8];             // Koti vej na letnem prirastu
                 float HPhi[128][8];            // Visina veje
               } TypeTree;

typedef struct { float X, Y, Z, Theta, Phi, Zoom;
               } TypeView;

typedef struct { char Name[13];
                 DB CharNo, PicNo;
                 char PalName[13];
               } TypeNames;

extern TypeVGA VGA;
extern TypeCMD Command;
extern TypeTree Tree;
extern TypeView View;
extern TypeNames Names;
extern DB Pal_Neu[768];
extern DB Pal_BGR[768];
extern DB TGA[18];
extern DB Done, Key;
           }

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
